/*
	File:		LanternEvents.h

	Contains:	Lantern events that a driver can send/handle
				This are the public lantern events.
	Copyright:	 1997 by Apple Computer Inc. All rights reserved.
	
	Obtained from NIE2.0 F1C2 build. 9/4/97
*/


#ifndef __LANTERNEVENTS_H
#define __LANTERNEVENTS_H

#include "LanternTypes.h"
																		// (call args)				:: {reply args}
// Events that the TLanternDriver instance can handle
// by adding an eventhandler
#define kLanternSendBuffer				kLanternEventClass,'sndB',2		// (Ptr, Size size)			:: {}
#define kLanternSendCBufferList			kLanternEventClass,'sndC',1		// (CBufferList*) 			:: {}
#define kLanternGetDeviceAddress		kLanternEventClass,'gdva',2		// (UByte* addr, Size size)	:: {}
#define kLanternGetLinkIntegrity		kLanternEventClass,'glit',0		// () 						:: {ULong link}
#define kLanternAddMulticastAddress		kLanternEventClass,'amca',1		// (UByte* addr) 			:: {}
#define kLanternDelMulticastAddress		kLanternEventClass,'dmca',1		// (UByte* addr) 			:: {}
// Note for Multicast Addresses:
// If the same multicast address is set twice the driver must maintain a count and remove the
// multicast address when the count reaches zero.

// Events that the TLanternDriver instance can generate
#define kLanternLinkIntegrity			kLanternEventClass,'link',1		// (ULong link)
#define kLanternDriverFailure			kLanternEventClass,'fail',1		// (NewtonErr reason)

// Optional events that a TLanternDriver may implement
// Promiscuous mode: listen to all packets (default is 0)
// promiscuous <> 0 enables promiscuous mode.
#define kLanternSetPromiscuous			kLanternEventClass,'prom',1		// (ULong promiscous)		:: ()
#define kLanternGetThroughput			kLanternEventClass,'getT',0		// ()						:: (ULong TotalThrough, ULong RxThrough, ULong TxThrough)

#endif	// __LANTERNEVENTS_H