/*
	File:		LanternTypes.h

	Contains:	Lantern defined types.

	Written by: Guy McIlroy

	Copyright:	 1997 by Apple Computer Inc. All rights reserved.

	Obtained from NIE2.0 F1C2 build. 9/4/97
*/
#ifndef __LANTERNTYPES_H
#define __LANTERNTYPES_H

#include "NewtonTypes.h"

typedef ULong	EventId;
typedef ULong	EventClass;
typedef ULong	PacketId;
typedef ULong	ArgCount;
typedef	void*	CObjectPtr;
typedef	void	(*CMethodPtr)(void*, ...);

#define kSizeOfArg 4
#define sizeofClassAsArgs(c)	((sizeof(c)+kSizeOfArg)/kSizeOfArg)

#define kLanternDriverName		"Lantern"

#define kLanternEventClass		'lant'
#define kLanternEventType		EventClass,EventId,ArgCount
#define kLanternRequestType		kLanternEventType

#ifdef NOT_NOW
enum
	{
	kLanternClientTAppWorld,
 	kLanternClientTCommTool,
	kLanternClientTEventWorld,
	};
#else
#define kLanternClientTAppWorld		0
#define kLanternClientTCommTool		1
#define kLanternClientTEventWorld	2
#endif
typedef ULong LanternClientTaskType;

#endif // __LANTERNTYPES_H
